#!/bin/sh
#
#       License: GPLv2
#       Author: review (http://www.mobileread.com/forums/member.php?u=88891)
#       Author: fortwienix (http://www.mobileread.com/forums/member.php?u=109732)
#
/ebrmain/bin/netagent connect
cd /mnt/ext1
agency=FAZ-$(date +%Y-%m-%d).html

if [ -d myrss-tmp ]; then 
  rm -rf myrss-tmp;
fi

mkdir myrss-tmp;
cd myrss-tmp;

echo '<html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"/></head><body>' > $agency

echo "0" > percent

for link in \
http://www.faz.net/s/RubA24ECD630CAE40E483841DB7D16F4211/Tpl~Epartner~SRss_.xml \
http://www.faz.net/s/RubC9401175958F4DE28E143E68888825F6/Tpl~Epartner~SRss_.xml \
http://www.faz.net/s/RubCC21B04EE95145B3AC877C874FB1B611/Tpl~Epartner~SRss_.xml \
http://www.faz.net/s/Rub9F27A221597D4C39A82856B0FE79F051/Tpl~Epartner~SRss_.xml \
http://www.faz.net/s/Rub02DBAA63F9EB43CEB421272A670A685C/Tpl~Epartner~SRss_.xml \
http://www.faz.net/s/Rub7F4BEE0E0C39429A8565089709B70C44/Tpl~Epartner~SRss_.xml \
http://www.faz.net/s/RubE2FB5CA667054BDEA70FB3BC45F8D91C/Tpl~Epartner~SRss_.xml
do
  wget -O feed $link
  grep -E "<title>|<link>" feed | tr -d \\r >> feed2
done

tail -f percent| /mnt/ext1/applications/tools/progressb.app &
total=$(grep -c ^ feed2);
current=0;
mode=0
cat feed2|
while read line; do
  current=$((current+1));
  echo $current $total|awk '{printf "%.0f\n",$1*100/$2}' >> percent

  cl=$(echo "$line" | grep "<title>")
  if [ "$cl " != " " ]; then
    title=$(echo "$line" | sed 's|<title>||;s|</title>||')
    mode=1
  else
    cl=$(echo "$line" | grep "<link>")
    if [ $mode -eq 1 ] && [ "$cl " != " " ]; then
      goodLink=$(echo "$line" | grep 'faz.net/aktuell/')
      echo $line
      echo $goodLink
      if [ -z $goodLink ]; then
        continue
      fi
      link=$(echo "$line" | sed 's|<link>||;s|</link>||')
    fi
    mode=2
  fi
  if [ $mode -ne 2 ]; then
    continue
  fi
  echo "write article with title: ${title}\n"
  echo "<h1>${title}</h1>" >> $agency
  mode=0
  
  rm article-raw
  wget -O article-raw "$link";
  cat article-raw|
    sed 's|<div|\n<div|g;s|</div>|</div>\n|g' > raw-formatted
  begin=$(cat raw-formatted |grep -n '<div class="FAZArtikelText"' |head -1|awk -F: '{print $1}')
  end=$(cat raw-formatted |grep -n '<div id="ArtikelTabContent_1'|head -1|awk -F: '{print $1}')
  if [ "$begin" != "" ] && [ "$end" != "" ]; then
    end=$((end-1))
    begin=$((end-begin))
    # the seds below are just to tidy up the toc of fbreader.
    cat raw-formatted|head -n $end|tail -n $begin |sed 's|<h[2-5]>|<b><br />|g;s|</h[2-5]>|</b>|g'>>$agency
    # add missing div from main article
    #echo "</div>">>$agency
  fi
done
echo "100" >> percent
echo '</body></html>' >> $agency
mv $agency /mnt/ext1/
cd ..
rm -rf myrss-tmp
/ebrmain/bin/netagent disconnect
